program main
  use sep
  implicit none


  integer :: nx, ny, nz, nhx, nhy, firstp
  real    :: ox, oy, oz, ohx, ohy
  real    :: dx, dy, dz, dhx, dhy
  integer :: ix, iy, iz, ngapx, ngapy, nwnd1,nwnd2,nwnd3,np,ip,pz,px,py,opy,opx,ppy,lastx=0
  real    :: z, zmin, zmax, dist, max_xoff, max_yoff

  real, dimension(:,:,:,:,:), allocatable :: mod1, mod2
  real,  dimension(:,:),allocatable         ::picks
  logical :: this_y

  call initpar()

  call from_history("n1", nhx); call from_history("o1", ohx); call from_history("d1", dhx)
  call from_history("n2", nhy); call from_history("o2", ohy); call from_history("d2", dhy)
  call from_history("n3", nx ); call from_history("o3", ox ); call from_history("d3", dx )
  call from_history("n4", ny ); call from_history("o4", oy ); call from_history("d4", dy )
  call from_history("n5", nz ); call from_history("o5", oz ); call from_history("d5", dz )

  call from_aux("picks","n2",np)


  call from_param("ngapx", ngapx, nhx )
  call from_param("ngapy", ngapy, nhy )
  call from_param("zmin", zmin, oz)
  call from_param("zmax", zmax, oz+(nz-1)*dz)
  call from_param("nwnd1", nwnd1, 1 )
  call from_param("nwnd2", nwnd2, 1 )
  call from_param("nwnd3", nwnd3, 1 )
  call from_param("firstp", firstp, 1 )
  


  !allocate(mod1(nhx,nhy,2*nwnd2+1,2*nwnd3+1,2*nwnd1+1))
  allocate(mod1(nhx,nhy,nx,ny,nz))
  allocate(mod2(nhx,nhy,nx,ny,nz),picks(3,np))

  call sreed("picks",picks,4*3*np)

     mod1 = 0.
     mod2 = 0. 
     !call sep_read(mod1)
     call sreed("in",mod1,4*nhx*nhy*nx*ny*nz)

!opy=(picks(3,1)-oy)/dy +1; 
 opx=(picks(2,firstp)-ox)/dx +1
!ppy=opy
!this_y=0

do ip=firstp,np

  pz=(picks(1,ip)-oz)/dz +1
  px=(picks(2,ip)-ox)/dx +1
  py=(picks(3,ip)-oy)/dy +1


!write(0,*) px,ngapx,real(real(px)/real(ngapx)),mod(px,ngapx),py,ngapy, real(real(py)/real(ngapy))
!write(0,*) opy,opx,ppy,(picks(3,ip)-oy)/dy +1,py,px
   if ( px .ne. lastx .and. ( ip==firstp .or. mod(px-opx,ngapx)==0 )  ) then

write(0,*) ip,px,py,pz+nwnd1
  lastx=px; 
  !call sreed_window("in",5,(/nhx,nhy,nx,ny,nz/),(/nhx,nhy,2*nwnd2+1,2*nwnd3+1,2*nwnd1+1/),(/0,0,px-nwnd2-1,py-nwnd3-1,pz-nwnd1-1/),(/1,1,1,1,1/),4,mod1)
!write(0,*) sum(mod1)
   do iz=-1*(nwnd1),(nwnd1)
    do iy=-1*nwnd3,nwnd3
     do ix=-1*(nwnd2),(nwnd2)      
       !dist=sqrt(real(ix*ix + iz*iz))
       !write(0,*) ix,dist
!write(0,*) iy,ix,iz
!write(0,*) mod1(:,:,0,0,0)-mod2(:,:,px+ix,py+iy,pz+iz)
       mod2(:,:,px+ix,py+iy,pz+iz) = mod1(:,:,px+ix,py+iy,pz+iz) !(:,:,ix+nwnd2+1,iy+nwnd3+1,iz+nwnd1+1)   !*exp(-3*dist)
      end do
     end do
    end do
   end if
end do


 call sep_write(mod2)


end program
