program main
  use sep
  use base_struct_mod
  use base_blkcal_mod
  use base_ioutil_mod

  implicit none

  type(axis)                                 :: ax, ay, az, ahx, ahy
  integer				     :: delta,ix
 
  real     , dimension(:,:,:,:,:)  , allocatable :: refl, output
  character(len=256)                         :: refl_, output_

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()


  refl_="refl"
  output_="output"

  call auxin(refl_); call auxout(output_)
  call hinaxis(refl_, ahx, 1); call hinaxis(refl_, ahy, 2); call hinaxis(refl_, ax , 3)
  call hinaxis(refl_, ay , 4); call hinaxis(refl_, az , 5)

  call houaxis(output_, ahx, 1); call houaxis(output_, ahy, 2); call houaxis(output_, ax , 3)
  call houaxis(output_, ay , 4); call houaxis(output_, az , 5)

 allocate(refl(ahx%n,ahy%n,ax%n,ay%n,az%n),output(ahx%n,ahy%n,ax%n,ay%n,az%n))

 call from_param("delta",delta,10)

 call sep_read(refl(:,:,:,:,:), refl_)  	

 output=0.

     do ix=1, ax%n,delta

      output(:,:,ix-1:ix+1,:,:) = refl(:,:,ix-1:ix+1,:,:)

     end do

   call  sep_write(output(:,:,:,:,:),output_)

 
end program
