program main
  use sep
  implicit none

  integer :: n1, n2, n3, n4, n5
  real    :: d1, d2, d3, d4, d5
  real    :: o1, o2, o3, o4, o5 
  real, dimension(:), allocatable :: modl

  call initpar()

  call from_param("n1", n1, 1); call from_param("d1", d1, 1.); call from_param("o1", o1, 0.)
  call from_param("n2", n2, 1); call from_param("d2", d2, 1.); call from_param("o2", o2, 0.)
  call from_param("n3", n3, 1); call from_param("d3", d3, 1.); call from_param("o3", o3, 0.)
  call from_param("n4", n4, 1); call from_param("d4", d4, 1.); call from_param("o4", o4, 0.)
  call from_param("n5", n5, 1); call from_param("d5", d5, 1.); call from_param("o5", o5, 0.)


  allocate(modl(n1*n2*n3*n4*n5))

  call random_seed()

  call random_number(modl)

  modl = modl*2-1

  call sep_write(modl)

  call to_history("n1", n1); call to_history("d1", d1); call to_history("o1", o1)
  call to_history("n2", n2); call to_history("d2", d2); call to_history("o2", o2)
  call to_history("n3", n3); call to_history("d3", d3); call to_history("o3", o3)
  call to_history("n4", n4); call to_history("d4", d4); call to_history("o4", o4)
  call to_history("n5", n5); call to_history("d5", d5); call to_history("o5", o5)


end program
