program Replace_vel
  !      

  use sep
  implicit none

  integer :: nt, nx,ny,ix,it,ck,it2,nt2,nx2,ot,ox,ot2,ox2
  real:: dt,dx,dy,t0,x0,y0,t1,x1
  real,  dimension(:,:),allocatable                                ::vel,input,output
  real, pointer, dimension(:,:)	        ::velrep
  write(0,*) 'after inits'
  !! hook up sep parameter input facility

  ! input is original velocity model; horiz=hor1.H in param
  call sep_init(SOURCE)


  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("d1",dt); call from_history("d2",dx);
  call from_history("o1",t0); call from_history("o2",x0);
  ! call from_history("n3",ny);
  write(0,*) 'n1/n2',nt,nx
  ny=1;dy=1.;y0=0.

  call to_history( "n1", nt);  call to_history( "n2", nx);!  call to_history( "n3", 1)
  call to_history( "d1", dt);  call to_history( "d2", dx); ! call to_history( "d3", 1)
  call to_history( "o1", t0);  call to_history( "o2", x0);!  call to_history( "o3", y0)
  call to_history("esize",4);

  nt2=106; nx2=526
  t1=2.30115; x1=6.00074
  ot=0.5+t1/dt; ox=0.5+x1/dx; ot2=ot+nt2-1; ox2=ox+nx2-1 
  write(0,*) 'ot ox ot2 ox2',ot,ox,ot2,ox2
 

  allocate(input(nt,nx),velrep(nt2,nx2),output(nt,nx),vel(nt,nx))
  write(0,*) 'after allocations'
  call sep_read(input)
velrep=1.
  if (exist_file("velrep"))  call sreed("velrep", velrep, 4*nt2*nx2) 
  write(0,*) 'read in data'
  
  output=0.
  vel=0.
  do ix=1,nx
   if(ix<ox.or.ix>ox2) vel(:,ix)=input(:,ix)
   if(ix>=ox.and.ix<=ox2) then
    do it=1,nt
     if(it<ot.or.it>ot2) vel(it,ix)=input(it,ix)
     if(it>=ot.and.it<=ot2) vel(it,ix)=velrep(it-ot+1,ix-ox+1)
    end do
   end if
  end do
     
  write(0,*) 'about to writ out'
  call srite("out",vel,4*nt*nx)

  call srite("junk",output,4*nt*nx)

end program Replace_vel
