program Edit_vel
  !

  use sep
  implicit none

  integer :: nt, nx,ny,ix,it,nx2,iy
  real:: dt,dx,dy,t0,x0,y0,sf
  real,  dimension(:,:,:),allocatable                      ::input,output
  write(0,*) 'after inits'
  !! hook up sep parameter input facility

  ! input is original velocity model; horiz=hor1.H in param
  call sep_init()


  call from_history("n1",nx); call from_history("n2",ny); call from_history("n3",nt)
  call from_history("d1",dx); call from_history("d2",dy); call from_history("d3",dt)
  call from_history("o1",x0); call from_history("o2",y0); call from_history("o3",t0)

  call from_param("sf",sf,1.0) 
 !call from_aux("horiz","n1",nx2)
  ! call from_history("n3",ny);
  write(0,*) 'n1/n2',nt,nx
  
  !call to_history( "n1", nt);  call to_history( "n2", nx);!  call to_history( "n3", 1)
  !call to_history( "d1", dt);  call to_history( "d2", dx); ! call to_history( "d3", 1)
  !call to_history( "o1", t0);  call to_history( "o2", x0);!  call to_history( "o3", y0)
  !call to_history("esize",4);
  ! call from_param("cutoff",cutoff,0.)

  allocate(input(nx,ny,nt),output(nx,ny,nt))
  write(0,*) 'after allocations'
  call sep_read(input)
  !if (exist_file("horiz"))  call sreed("horiz", horiz, 4*nt*nx) 
  write(0,*) 'read in data'
  ! write(0,*) 'cutoff',cutoff

  output=input 
  
  do it=1,nt

    do iy=1,ny 
     do ix=1,nx
      if (input(ix,iy,it)==14800) then		! (it-?): ? = sigs.H o1/d1
	output(ix,iy,it)=14800*sf			! salt=14800 (chg everywhere for base resolution)
	!write(0,*) it,horiz(ix-1000,1)
      end if
     end do 
   end do
  end do

  write(0,*) 'about to writ out'
  call srite("out",output,4*nt*nx*ny)

  !call srite("junk",output,4*nt*nx)

end program
