program Gain_corr
  !

  use sep
  implicit none

  integer :: nt,nhx,nhy,nsx,nsy,isx,isy,it,ihy,ihx
  real:: dt,dhx,dhy,t0,hx0,hy0,dsx,dsy,osx,osy,ohx,ohy,hy,hx
  real,  dimension(:,:,:),allocatable                      ::input,output
  real, dimension(:), allocatable :: t,gain,velgain
  real, dimension(:), allocatable :: offset
  write(0,*) 'after inits'
  !! hook up sep parameter input facility

  ! input is original velocity model; horiz=hor1.H in param
  call sep_init()


  call from_history("n1",nt); call from_history("n2",nhx); call from_history("n3",nsx)
  !call from_history("n4",nsx); call from_history("n5",nsy)
  call from_history("d1",dt); call from_history("d2",dhx); call from_history("d3",dsx)
  !call from_history("d4",dsx); call from_history("d5",dsy)
  call from_history("o1",t0); call from_history("o2",ohx); call from_history("o3",osx)
  !call from_history("o4",osx); call from_history("o5",osy)

  !call from_param("maxsize",maxsize,100) 
 !call from_aux("horiz","n1",nx2)
  ! call from_history("n3",ny);
  write(0,*) 'hx/hy',nhx,nhy
  
  !call to_history( "n1", nt);  call to_history( "n2", nx);!  call to_history( "n3", 1)
  !call to_history( "d1", dt);  call to_history( "d2", dx); ! call to_history( "d3", 1)
  !call to_history( "o1", t0);  call to_history( "o2", x0);!  call to_history( "o3", y0)
  !call to_history("esize",4);
  ! call from_param("cutoff",cutoff,0.)
  call to_history("n1",nt); call to_history("n2",nhx); call to_history("n3",nsx)
  !call to_history("n4",nsx); call to_history("n5",nsy)
  call to_history("d1",dt); call to_history("d2",dhx); call to_history("d3",dsx)
  !call to_history("d4",dsx); call to_history("d5",dsy)
  call to_history("o1",t0); call to_history("o2",ohx); call to_history("o3",osx)
  !call to_history("o4",osx); call to_history("o5",osy)

  !nblocks=maxsize*1000000/5/4
  !nouter=ceiling(n1*n2*n3*n4*n5*4/nblocks)

 allocate(velgain(nt),gain(nt),t(nt),offset(nhx))
 do it=1,nt
  t(it)= t0+(it-1)*dt 
 end do
velgain=(4.9e-14*t**4 + 2.2e-10*t**3 - 4.8e-5*t**2 + 0.7*t + 1.5e3)**2 / (1500**2)
write(0,*) velgain

 do ihx=1,nhx
  offset(ihx) = abs(ohx + (ihx-1)*dhx)
 end do
write(0,*) offset*0.0004375
 allocate(input(nt,nhx,nsx),output(nt,nhx,nsx)) 
 output=input

 call sreed("in",input,nt*nhx*nsx*4)
 
  !write(0,*) 'after allocations, shot',isy,isx
 ! call sreed_window("in",5,(/nt,nhx,nhy,nsx,nsy/),(/nt,nhx,nhy,1,1/),(/0,0,0,isx-1,isy-1/),(/1,1,1,1,1/),4,input)
    !call seperr("trouble reading in")
  !end if
  !if (exist_file("horiz"))  call sreed("horiz", horiz, 4*nt*nx) 
  !write(0,*) 'read in data'
  ! write(0,*) 'cutoff',cutoff

  
 
 ! if (sum(input*input) .ne. 0) then

  do isx=1,nsx
    do ihx=1,nhx      
      !if (isx==1 .and. ihx==10) write(0,*) offset(ihx), (0.0004375 * offset(ihx))
       gain=velgain *  max(0.0,(t - (0.0003125 * offset(ihx)))) ** 2.8
       output(:,ihx,isx) = gain*input(:,ihx,isx)
!write(0,*) gain
    end do
  end do
 ! end if

 !call srite_window("out",5,(/nt,nhx,nhy,nsx,nsy/),(/nt,nhx,nhy,1,1/),(/0,0,0,isx-1,isy-1/),(/1,1,1,1,1/),4,output)

 call srite("out",output,nt*nhx*nsx*4)

 deallocate(input,output)



 ! call srite("out",output,4*nt*nx*ny)

  !call srite("junk",output,4*nt*nx)

end program
